/*******************************************************************************
* File Name: CLK_6MHz.h
* Version 2.20
*
*  Description:
*   Provides the function and constant definitions for the clock component.
*
*  Note:
*
********************************************************************************
* Copyright 2008-2012, Cypress Semiconductor Corporation.  All rights reserved.
* You may use this file only in accordance with the license, terms, conditions, 
* disclaimers, and limitations in the end user license agreement accompanying 
* the software package with which this file was provided.
*******************************************************************************/

#if !defined(CY_CLOCK_CLK_6MHz_H)
#define CY_CLOCK_CLK_6MHz_H

#include <cytypes.h>
#include <cyfitter.h>


/***************************************
*        Function Prototypes
***************************************/
#if defined CYREG_PERI_DIV_CMD

void CLK_6MHz_StartEx(uint32 alignClkDiv);
#define CLK_6MHz_Start() \
    CLK_6MHz_StartEx(CLK_6MHz__PA_DIV_ID)

#else

void CLK_6MHz_Start(void);

#endif/* CYREG_PERI_DIV_CMD */

void CLK_6MHz_Stop(void);

void CLK_6MHz_SetFractionalDividerRegister(uint16 clkDivider, uint8 clkFractional);

uint16 CLK_6MHz_GetDividerRegister(void);
uint8  CLK_6MHz_GetFractionalDividerRegister(void);

#define CLK_6MHz_Enable()                         CLK_6MHz_Start()
#define CLK_6MHz_Disable()                        CLK_6MHz_Stop()
#define CLK_6MHz_SetDividerRegister(clkDivider, reset)  \
    CLK_6MHz_SetFractionalDividerRegister((clkDivider), 0u)
#define CLK_6MHz_SetDivider(clkDivider)           CLK_6MHz_SetDividerRegister((clkDivider), 1u)
#define CLK_6MHz_SetDividerValue(clkDivider)      CLK_6MHz_SetDividerRegister((clkDivider) - 1u, 1u)


/***************************************
*             Registers
***************************************/
#if defined CYREG_PERI_DIV_CMD

#define CLK_6MHz_DIV_ID     CLK_6MHz__DIV_ID

#define CLK_6MHz_CMD_REG    (*(reg32 *)CYREG_PERI_DIV_CMD)
#define CLK_6MHz_CTRL_REG   (*(reg32 *)CLK_6MHz__CTRL_REGISTER)
#define CLK_6MHz_DIV_REG    (*(reg32 *)CLK_6MHz__DIV_REGISTER)

#define CLK_6MHz_CMD_DIV_SHIFT          (0u)
#define CLK_6MHz_CMD_PA_DIV_SHIFT       (8u)
#define CLK_6MHz_CMD_DISABLE_SHIFT      (30u)
#define CLK_6MHz_CMD_ENABLE_SHIFT       (31u)

#define CLK_6MHz_CMD_DISABLE_MASK       ((uint32)((uint32)1u << CLK_6MHz_CMD_DISABLE_SHIFT))
#define CLK_6MHz_CMD_ENABLE_MASK        ((uint32)((uint32)1u << CLK_6MHz_CMD_ENABLE_SHIFT))

#define CLK_6MHz_DIV_FRAC_MASK  (0x000000F8u)
#define CLK_6MHz_DIV_FRAC_SHIFT (3u)
#define CLK_6MHz_DIV_INT_MASK   (0xFFFFFF00u)
#define CLK_6MHz_DIV_INT_SHIFT  (8u)

#else 

#define CLK_6MHz_DIV_REG        (*(reg32 *)CLK_6MHz__REGISTER)
#define CLK_6MHz_ENABLE_REG     CLK_6MHz_DIV_REG
#define CLK_6MHz_DIV_FRAC_MASK  CLK_6MHz__FRAC_MASK
#define CLK_6MHz_DIV_FRAC_SHIFT (16u)
#define CLK_6MHz_DIV_INT_MASK   CLK_6MHz__DIVIDER_MASK
#define CLK_6MHz_DIV_INT_SHIFT  (0u)

#endif/* CYREG_PERI_DIV_CMD */

#endif /* !defined(CY_CLOCK_CLK_6MHz_H) */

/* [] END OF FILE */
