/*******************************************************************************
* File Name: capture_int.h
* Version 1.70
*
*  Description:
*   Provides the function definitions for the Interrupt Controller.
*
*
********************************************************************************
* Copyright 2008-2015, Cypress Semiconductor Corporation.  All rights reserved.
* You may use this file only in accordance with the license, terms, conditions, 
* disclaimers, and limitations in the end user license agreement accompanying 
* the software package with which this file was provided.
*******************************************************************************/
#if !defined(CY_ISR_capture_int_H)
#define CY_ISR_capture_int_H


#include <cytypes.h>
#include <cyfitter.h>

/* Interrupt Controller API. */
void capture_int_Start(void);
void capture_int_StartEx(cyisraddress address);
void capture_int_Stop(void);

CY_ISR_PROTO(capture_int_Interrupt);

void capture_int_SetVector(cyisraddress address);
cyisraddress capture_int_GetVector(void);

void capture_int_SetPriority(uint8 priority);
uint8 capture_int_GetPriority(void);

void capture_int_Enable(void);
uint8 capture_int_GetState(void);
void capture_int_Disable(void);

void capture_int_SetPending(void);
void capture_int_ClearPending(void);


/* Interrupt Controller Constants */

/* Address of the INTC.VECT[x] register that contains the Address of the capture_int ISR. */
#define capture_int_INTC_VECTOR            ((reg32 *) capture_int__INTC_VECT)

/* Address of the capture_int ISR priority. */
#define capture_int_INTC_PRIOR             ((reg32 *) capture_int__INTC_PRIOR_REG)

/* Priority of the capture_int interrupt. */
#define capture_int_INTC_PRIOR_NUMBER      capture_int__INTC_PRIOR_NUM

/* Address of the INTC.SET_EN[x] byte to bit enable capture_int interrupt. */
#define capture_int_INTC_SET_EN            ((reg32 *) capture_int__INTC_SET_EN_REG)

/* Address of the INTC.CLR_EN[x] register to bit clear the capture_int interrupt. */
#define capture_int_INTC_CLR_EN            ((reg32 *) capture_int__INTC_CLR_EN_REG)

/* Address of the INTC.SET_PD[x] register to set the capture_int interrupt state to pending. */
#define capture_int_INTC_SET_PD            ((reg32 *) capture_int__INTC_SET_PD_REG)

/* Address of the INTC.CLR_PD[x] register to clear the capture_int interrupt. */
#define capture_int_INTC_CLR_PD            ((reg32 *) capture_int__INTC_CLR_PD_REG)



#endif /* CY_ISR_capture_int_H */


/* [] END OF FILE */
